プログラマのためのGulp入門

# 対象

nodejsがわからない ふつうのプログラマ

# 目的

Gulp最初よくわからなかった。
わかるようになってきたので伝える

# キーワード

Gulp = make + ファイル監視
Gulp = rake + guard
Gulp = Stream + Vinyl + Orchestrator
Gulp = ストリーム + ファイルっぽいもの + タスクランナー
Gulpのプラグイン = Vinylのストリームをうけとって仕事をして Vinylのストリームをつくる

# 内容

## Gulpとは

タスクランナーってやつ
Web開発で流行っている
タスクランナーはプラグラマなら元々流行してる
make + ファイル監視
railsプログラマなら当然使ってる
rake + guard
それでもGulpの良いところ -> nodejsであること

## Gulpの基本

```glup-abc.js
var gulp = require('gulp');

// タスク定義
gulp.task("hoge", function () {
  // タスクの内容
  gulp.src("src/*")
    .pipe(gulp.dest("dest"));
});

// $ gulp hoge の代わり
gulp.start(['hoge']);
```


```
for file in src/*
  do cat < $file > dest/`basename $file`
done
```

srcディレクトリにあるファイルのストリームを作成してdestディレクトリのファイルに流しこむ

## Gulp の中身

Gulp = Stream + Vinyl + Orchetsrator
Gulp = ストリーム + ファイルっぽいもの + ファイル監視 + タスクランナー

GulpのAPI

* gulp.src
* gulp.dest
* gulp.task
* gulp.watch

source code
https://github.com/gulpjs/gulp/blob/v3.8.11/index.js

```
var Orchestrator = require('orchestrator');

function Gulp() {
  Orchestrator.call(this);
}
util.inherits(Gulp, Orchestrator);

Gulp.prototype.task = Gulp.prototype.add;
```

```
var vfs = require('vinyl-fs');

Gulp.prototype.src = vfs.src;
Gulp.prototype.dest = vfs.dest;
Gulp.prototype.watch = function (glob, opt, fn) {
  // (中略)
  return vfs.watch(glob, opt, fn);
};
```


## ストリーム

Gulpの処理はストリームです。
パイプで繋げばよい

ストリームといえば shell script

 a | b | c
a.pipe(b).pipe(c)

```
echo hoge | sed s/hoge/goro/g
```

```
for file in "mogu.txt"
do echo hoge | sed s/hoge/goro/g > ./$file
done
```

注意 シェルやっているのはBufferのストリーム
Gulpで扱うのは Vinylのストリーム

```
var run = require('gulp-run');
run("echo hoge").exec()
  .pipe(run("sed s/hoge/goro/g"));
```

さきほどかいたコードは [Bufferのストリーム]のストリーム
Bufferのストリーム = Vinyl

## Vinyl

Vinylは

* ファイルの中身
* ファイルのパス
* カレントディレクトリ

を保持している

GulpPlugin Stearm Vinyl
data Vinyl = Vinyl Path (Stream Buffer) | Vinyl Path Buffer | Vinyl Path Null
Stream = ReaderStream | WriterStream | TransformStream | DuplexStream

TransformStream は ThroughStreamとも言われる

## Gulpのプラグイン

VinylストリームのTransformStream(ThroughStream)をつくる

gulp.src ReaderStearm
gulp.dest WriterStream

Vinyl-s3

## TransformStreamの作成

event-stream.map で持ち上げ
through.objを使用する

Nodejsのストリームがわかれば大丈夫
